## freedv 1.8.7

=== CMakeLists.txt ===
#
# FreeDV - HF Digital Voice for Radio Amateurs
#
# CMake configuration contributed by Richard Shaw (KF5OIM)
# Please report questions, comments, problems, or patches to the freetel
# mailing list: https://lists.sourceforge.net/lists/listinfo/freetel-codec2
#
cmake_minimum_required(VERSION 3.13)

# Avoid warning about DOWNLOAD_EXTRACT_TIMESTAMP in CMake 3.24.
if (CMAKE_VERSION VERSION_GREATER_EQUAL "3.24.0")
	cmake_policy(SET CMP0135 NEW)
endif()

set(CMAKE_OSX_DEPLOYMENT_TARGET "10.11" CACHE STRING "Minimum OS X deployment version")

set(PROJECT_NAME FreeDV)
set(PROJECT_VERSION 1.8.7)
set(PROJECT_DESCRIPTION "HF Digital Voice for Radio Amateurs")
set(PROJECT_HOMEPAGE_URL "https://freedv.org")

# Makes FreeDV overridden CMake platform available for ARM MinGW builds.
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/")

if(APPLE)
    project(
        ${PROJECT_NAME}
        VERSION ${PROJECT_VERSION}
        DESCRIPTION ${PROJECT_DESCRIPTION}
        HOMEPAGE_URL ${PROJECT_HOMEPAGE_URL}
        LANGUAGES C CXX OBJCXX
    )
else(APPLE)
    project(
        ${PROJECT_NAME}
        VERSION ${PROJECT_VERSION}
        DESCRIPTION ${PROJECT_DESCRIPTION}
        HOMEPAGE_URL ${PROJECT_HOMEPAGE_URL}
        LANGUAGES C CXX
    )
endif(APPLE)    

# Adds a tag to the end of the version string. Leave empty
# for official release builds.
set(FREEDV_VERSION_TAG "")

# Prevent in-source builds to protect automake/autoconf config.
# If an in-source build is attempted, you will still need to clean up a few
# files manually.
set(CMAKE_DISABLE_SOURCE_CHANGES ON)
set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)
if("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
  message(FATAL_ERROR "In-source builds in ${CMAKE_BINARY_DIR} are not "
   "allowed, please remove ./CMakeCache.txt and ./CMakeFiles/, create a "
   "separate build directory and run cmake from there.")
endif("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")

# Set local module path.
list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

# Build universal ARM64 and x86_64 binaries on Mac.
if(BUILD_OSX_UNIVERSAL)
set(CMAKE_OSX_ARCHITECTURES "x86_64;arm64")
endif(BUILD_OSX_UNIVERSAL)

# Return the date (yyyy-mm-dd)
string(TIMESTAMP DATE_RESULT "%Y-%m-%d" UTC)
message(STATUS "Compilation date = XX${DATE_RESULT}XX")

#
# generate src/version.h
#
configure_file(cmake/version.h.in src/version.h @ONLY)

# Set default build type
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Debug")
    message(STATUS "Build type not specified, defaulting to ${CMAKE_BUILD_TYPE}")
endif(NOT CMAKE_BUILD_TYPE)

# Work around for not using a svn working copy.
#add_definitions(-D_NO_AUTOTOOLS_)

#
# Find the git hash if this is a working copy.
#
if(EXISTS ${CMAKE_SOURCE_DIR}/.git)
    find_package(Git QUIET)
    if(Git_FOUND)
        execute_process(
            COMMAND "${GIT_EXECUTABLE}" describe --always HEAD
            WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
            RESULT_VARIABLE res
            OUTPUT_VARIABLE FREEDV_HASH
            ERROR_QUIET
            OUTPUT_STRIP_TRAILING_WHITESPACE)
        message(STATUS "freedv-gui current git hash: ${FREEDV_HASH}")
        add_definitions(-DGIT_HASH="${FREEDV_HASH}")
    else()
        message(WARNING "Git not found. Can not determine current commit hash.")
        add_definitions(-DGIT_HASH="Unknown")
    endif()
else()
        add_definitions(-DGIT_HASH="None")
endif()

# Set default build flags.
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
if(APPLE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
endif(APPLE)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

#
# Setup cmake options
#
set(CMAKE_VERBOSE_MAKEFILE TRUE CACHE BOOL "Verbose makefile.")
set(CMAKE_EXPORT_COMPILE_COMMANDS TRUE CACHE BOOL "Enable IDE features.")
set(USE_INTERNAL_CODEC2 FALSE CACHE BOOL
    "Download and build codec2 and lpcnetfreedv instead of using the system library.")
set(USE_STATIC_DEPS FALSE CACHE BOOL
    "Download and build static libraries instead of system libraries.")
set(USE_STATIC_PORTAUDIO FALSE CACHE BOOL
    "Download and build static portaudio instead of the system library.")
set(USE_STATIC_SNDFILE FALSE CACHE BOOL
    "Download and build static sndfile instead of the system library.")
set(USE_STATIC_SAMPLERATE FALSE CACHE BOOL
    "Download and build static samplerate instead of the system library.")
set(USE_STATIC_SPEEXDSP FALSE CACHE BOOL
    "Download and build static speex instead of the system library.")
set(BOOTSTRAP_WXWIDGETS FALSE CACHE BOOL
    "Download and build static wxWidgets instead of the system library.")
set(USE_PULSEAUDIO FALSE CACHE BOOL
    "Use PulseAudio instead of PortAudio for audio I/O.")

if(USE_STATIC_DEPS)
    set(USE_STATIC_PORTAUDIO TRUE FORCE)
    set(USE_STATIC_SNDFILE TRUE FORCE)
    set(USE_STATIC_SAMPLERATE TRUE FORCE)
    set(USE_STATIC_SPEEXDSP TRUE FORCE)
endif(USE_STATIC_DEPS)

#
# Find wxWidgets
#
set(DARK_MODE_DISABLE "false")
if(NOT BOOTSTRAP_WXWIDGETS)
    message(STATUS "Looking for wxWidgets...")
    if(WXCONFIG)
        message(STATUS "wx-config: ${WXCONFIG}")
        set(wxWidgets_CONFIG_EXECUTABLE ${WXCONFIG})
    endif(WXCONFIG)
    if(WXRC)
        message(STATUS "wxrc: ${WXRC}")
        set(wxWidgets_wxrc_EXECUTABLE ${WXRC})
    endif(WXRC)
    set(WX_VERSION_MIN 3.0.0)
    set(WX_31_VERSION_MIN 3.1.3)
    find_package(wxWidgets COMPONENTS core base aui html net adv propgrid)
    if(NOT wxWidgets_FOUND)
        set(BOOTSTRAP_WXWIDGETS TRUE)
    else()
        execute_process(COMMAND sh "${wxWidgets_CONFIG_EXECUTABLE}" --version
            OUTPUT_VARIABLE WX_VERSION)
        string(STRIP ${WX_VERSION} WX_VERSION)
        if(WX_VERSION VERSION_EQUAL ${WX_VERSION_MIN}
           OR WX_VERSION VERSION_GREATER ${WX_VERSION_MIN})
            message(STATUS "wxWidgets version: ${WX_VERSION}")
        else()
            set(BOOTSTRAP_WXWIDGETS TRUE)
        endif()
    endif()
endif()

if(BOOTSTRAP_WXWIDGETS)
    message(STATUS "Adding wxWidgets build target...")
    include(cmake/BuildWxWidgets.cmake)
else()
    if(APPLE)
        if(WX_VERSION VERSION_EQUAL ${WX_31_VERSION_MIN}
           OR WX_VERSION VERSION_GREATER ${WX_31_VERSION_MIN})
            set(DARK_MODE_DISABLE "false")
        else()
            set(DARK_MODE_DISABLE "true")
       endif()
    endif(APPLE)
endif()

#
# Various hacks and work arounds for building under MinGW.
#
if(MINGW)
    message(STATUS "System is MinGW.")
    # Default to static build of portaudio until I can figure out why the
    # shared DLL doesn't work.
    set(USE_STATIC_PORTAUDIO TRUE)
    unset(USE_INTERNAL_CODEC2 CACHE)
    set(USE_INTERNAL_CODEC2 TRUE CACHE BOOL "Perform nternal buils of codec2 and lpcnetfreedv")
    # Setup HOST variables.
    include(cmake/MinGW.cmake)
    # This sets up the exe icon for windows under mingw.
    set(RES_FILES "")
    set(RES_FILES "${CMAKE_SOURCE_DIR}/contrib/freedv.rc")
    set(CMAKE_RC_COMPILER_INIT windres)
    enable_language(RC)
    set(CMAKE_RC_COMPILE_OBJECT
        "<CMAKE_RC_COMPILER> <FLAGS> -O coff <DEFINES> -i <SOURCE> -o <OBJECT>")
    include(InstallRequiredSystemLibraries)
endif(MINGW)

# Math library is automatic on MinGW
if(UNIX)
    set(CMAKE_REQUIRED_INCLUDES math.h)
    set(CMAKE_REQUIRED_LIBRARIES m)
endif(UNIX)

# Find some standard headers and functions.
include(CheckIncludeFiles)
check_include_files("byteswap.h"   HAVE_BYTESWAP_H)
check_include_files("limits.h"     HAVE_LIMITS_H)
check_include_files("stddef.h"     HAVE_STDDEF_H)
check_include_files("stdlib.h"     HAVE_STDLIB_H)
check_include_files("string.h"     HAVE_STRING_H)
check_include_files("strings.h"    HAVE_STRINGS_H)
check_include_files("ltdl.h"       HAVE_LTDL_H)
check_include_files("inttypes.h"   HAVE_INTTYPES_H)
check_include_files("sys/stat.h"   HAVE_SYS_STAT_H)
check_include_files("sys/types.h"  HAVE_SYS_TYPES_H)

include(CheckTypeSize)
check_type_size("int" SIZEOF_INT)

include(CheckFunctionExists)
check_function_exists(floor HAVE_FLOOR)
check_function_exists(memset HAVE_MEMSET)
check_function_exists(pow HAVE_POW)
check_function_exists(sqrt HAVE_SQRT)
check_function_exists(fseeko HAVE_FSEEKO)
check_function_exists(fmemopen HAVE_FMEMOPEN)
check_function_exists(strcasecmp HAVE_STRCASECMP)
check_function_exists(vsnprintf HAVE_VSNPRINTF)

include(CheckSymbolExists)
check_symbol_exists("_fseeki64" "stdio.h" HAVE__FSEEKI64)

# main.h requires patching to find config.h as it current looks in the
# source directory and the generated file goes in the binary directory.
configure_file ("${PROJECT_SOURCE_DIR}/cmake/config.h.in"
                "${PROJECT_BINARY_DIR}/config.h" )
include_directories(${PROJECT_BINARY_DIR})

# Config file for bundled sox sources
configure_file("${PROJECT_SOURCE_DIR}/cmake/soxconfig.h.in"
               "${PROJECT_BINARY_DIR}/soxconfig.h")

# Pthread Library
# Actually not needed if compiling with c++11 or higher...
find_package(Threads REQUIRED)
message(STATUS "Threads library flags: ${CMAKE_THREAD_LIBS_INIT}")


#
# Find codec2 and lpcnetfreedv
#
if(CODEC2_BUILD_DIR)
    if(USE_INTERNAL_CODEC2)
        set(USE_INTERNAL_CODEC2 FALSE)
        message(WARNING "Use of build directories and internal builds are mutually exclusive. Forcing internal builds off.")
    endif()
    set(USE_INTERNAL_CODEC2 OFF CACHE BOOL "" FORCE)
    message(STATUS "Using codec2 from build directory...")

    # Theoretically this isn't needed due to the PATHS argument below, but 
    # Fedora 37 (inside the Docker container) can't find Codec2 without it.
    set(codec2_DIR ${CODEC2_BUILD_DIR})

    find_package(codec2 REQUIRED
        NO_DEFAULT_PATH
        PATHS ${CODEC2_BUILD_DIR}
        CONFIGS codec2.cmake
    )
    get_target_property(CODEC2_INCLUDE_DIRS codec2 INTERFACE_INCLUDE_DIRECTORIES)
    if(LPCNET_BUILD_DIR)
        message(STATUS "Using LPCNet from build directory...")
        set(lpcnet_DIR ${LPCNET_BUILD_DIR})
        find_package(lpcnet REQUIRED
            NO_DEFAULT_PATH
            PATHS ${LPCNET_BUILD_DIR}
            CONFIGS lpcnetfreedv.cmake
        )
    else()
        message(FATAL_ERROR "Must use LPCNet from build directory if using codec2 from build directory.")
    endif()
elseif(USE_INTERNAL_CODEC2)
    message(STATUS "Will attempt internal build of codec2 and lpcnetfreedv.")
    include(cmake/BuildCodec2.cmake)
else(CODEC2_BUILD_DIR)
    message(STATUS "Looking for codec2...")
    # 'CONFIG' removed due to incompatibility with cmake version
    # in Ubuntu 12.04 (Precise) -- Stuart Longland
    find_package(codec2 QUIET)
    if(codec2_FOUND)
        get_target_property(CODEC2_LIBRARY codec2 LOCATION)
        get_target_property(CODEC2_INCLUDE_DIRS codec2 INTERFACE_INCLUDE_DIRECTORIES)
        message(STATUS "  codec2 library: ${CODEC2_LIBRARY}")
        message(STATUS "  codec2 headers: ${CODEC2_INCLUDE_DIRS}")
        find_package(lpcnetfreedv REQUIRED)
    else()
        # Try to find manually
        find_path(CODEC2_INCLUDE_DIRS codec2.h
                  PATH_SUFFIXES codec2)
        find_library(CODEC2_LIBRARY NAMES codec2)
        if(CODEC2_LIBRARY AND CODEC2_INCLUDE_DIRS)
            message(STATUS "  codec2 library: ${CODEC2_LIBRARY}")
            message(STATUS "  codec2 headers: ${CODEC2_INCLUDE_DIRS}")
            list(APPEND FREEDV_LINK_LIBS ${CODEC2_LIBRARY})
            include_directories(${CODEC2_INCLUDE_DIRS})
        else()
            message(STATUS "Will attempt internal build of codec2 and lpcnetfreedv.")
            include(cmake/BuildCodec2.cmake)
        endif()
    endif()
endif(CODEC2_BUILD_DIR)


#
# Find or build portaudio/PulseAudio Library
#
if(NOT USE_STATIC_PORTAUDIO AND NOT USE_PULSEAUDIO)
    message(STATUS "Looking for portaudio...")
    find_package(portaudio-2.0 REQUIRED)
    if(PORTAUDIO_FOUND)
        message(STATUS "  portaudio library: ${PORTAUDIO_LIBRARIES}")

=== src/CMakeLists.txt ===
set(FREEDV_SOURCES
    dlg_audiooptions.cpp
    dlg_easy_setup.cpp
    dlg_filter.cpp
    dlg_options.cpp
    dlg_ptt.cpp
    main.cpp
    plot.cpp
    plot_scalar.cpp
    plot_scatter.cpp
    plot_spectrum.cpp
    plot_waterfall.cpp
    hamlib.cpp
    serialport.cpp
    topFrame.cpp
    sox_biquad.c
    sox_biquad.h
    comp.h
    dlg_audiooptions.h
    dlg_filter.h
    dlg_options.h
    dlg_ptt.h
    defines.h
    main.h
    plot.h
    plot_scalar.h
    plot_scatter.h
    plot_spectrum.h
    plot_waterfall.h
    hamlib.h
    topFrame.h
    version.h
    osx_interface.h
    pskreporter.cpp
    pskreporter.h
    udp.cpp
    util.cpp
    eq.cpp
    voicekeyer.cpp
    playrec.cpp
    ongui.cpp
    freedv_interface.cpp
    freedv_interface.h        
)

set(FREEDV_SOURCES_OSX
    osx_interface.mm
)

set(FREEDV_LINK_LIBS_OSX
    "-framework AVFoundation"
)

# Compile FreeDV components
add_subdirectory(audio)
add_subdirectory(pipeline)
add_subdirectory(sox)

# WIN32 is needed for Windows GUI apps and is ignored for UNIX like systems.
# In addition, there are some required OSX-specific code files for platform specific handling.
if(APPLE)
    set(RES_FILES freedv.icns)
    set_source_files_properties(freedv.icns PROPERTIES MACOSX_PACKAGE_LOCATION "Resources")
    add_executable(FreeDV MACOSX_BUNDLE ${FREEDV_SOURCES} ${RES_FILES} ${FREEDV_SOURCES_OSX})
    set_target_properties(FreeDV PROPERTIES
        BUNDLE True
        MACOSX_BUNDLE_GUI_IDENTIFIER org.freedv.freedv
        MACOSX_BUNDLE_BUNDLE_NAME FreeDV
        MACOSX_BNUDLE_COPYRIGHT "Copyright (c) 2021 FreeDV"
        MACOSX_BUNDLE_BUNDLE_VERSION "${FreeDV_VERSION}"
        MACOSX_BUNDLE_BUNDLE_SHORT_VERSION_STRING "${FreeDV_VERSION}"
        MACOSX_BUNDLE_BUNDLE_LONG_VERSION_STRING "${FreeDV_VERSION}"
        MACOSX_BUNDLE_ICON_FILE "freedv"
        MACOSX_BUNDLE_INFO_PLIST ${CMAKE_SOURCE_DIR}/src/info.plist.in
    )
else()
    add_executable(freedv WIN32 ${FREEDV_SOURCES} ${RES_FILES})
endif(APPLE)

# Link imported or build tree targets.
if(APPLE)
target_link_libraries(FreeDV fdv_audio fdv_audio_pipeline fdv_sox lpcnetfreedv codec2)
else(APPLE)
target_link_libraries(freedv fdv_audio fdv_audio_pipeline fdv_sox lpcnetfreedv codec2)
endif(APPLE)

# Add build dependencies for internally built external libraries.
if(USE_INTERNAL_CODEC2)
    if(APPLE)
        add_dependencies(FreeDV build_codec2 build_lpcnetfreedv)
    else(APPLE)
        add_dependencies(freedv build_codec2 build_lpcnetfreedv)
    endif(APPLE)
endif()

# Add dependencies for other statically built libraries, if applicable.
if(FREEDV_STATIC_DEPS)
    if(APPLE)
    add_dependencies(FreeDV ${FREEDV_STATIC_DEPS})
    else(APPLE)
    add_dependencies(freedv ${FREEDV_STATIC_DEPS})
    endif(APPLE)
    add_dependencies(fdv_audio ${FREEDV_STATIC_DEPS})
    add_dependencies(fdv_audio_pipeline ${FREEDV_STATIC_DEPS})
    add_dependencies(fdv_sox ${FREEDV_STATIC_DEPS})
endif(FREEDV_STATIC_DEPS)

# Link other dependencies
if(APPLE)
target_link_libraries(FreeDV ${FREEDV_LINK_LIBS} ${FREEDV_LINK_LIBS_OSX})
elseif(WIN32)
target_link_libraries(freedv ${FREEDV_LINK_LIBS} ws2_32)
else()
target_link_libraries(freedv ${FREEDV_LINK_LIBS})
endif(APPLE)

if(BOOTSTRAP_WXWIDGETS)
    if(APPLE)
        target_compile_definitions(FreeDV PRIVATE ${WXBUILD_BUILD_DEFS})
        target_include_directories(FreeDV PRIVATE ${WXBUILD_INCLUDES})
        
        add_dependencies(FreeDV wx::core wx::base wx::aui wx::html wx::net wx::adv wx::propgrid wx::xrc)
        target_link_libraries(FreeDV wx::core wx::base wx::aui wx::html wx::net wx::adv wx::propgrid)
    else(APPLE)
        target_compile_definitions(freedv PRIVATE ${WXBUILD_BUILD_DEFS})
        target_include_directories(freedv PRIVATE ${WXBUILD_INCLUDES})
        
        add_dependencies(freedv wx::core wx::base wx::aui wx::html wx::net wx::adv wx::propgrid wx::xrc)
        target_link_libraries(freedv wx::core wx::base wx::aui wx::html wx::net wx::adv wx::propgrid)
    endif(APPLE)
endif(BOOTSTRAP_WXWIDGETS)

# For older Xcode (< 9.0), bypass usage of @available.
if(APPLE)
if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9.0.0.900037)
add_definitions(-DAPPLE_OLD_XCODE)
endif(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9.0.0.900037)
endif(APPLE)

# If a release tag's set, pass it to the compiler.
if(FREEDV_VERSION_TAG)
add_definitions(-DFREEDV_VERSION_TAG="${FREEDV_VERSION_TAG}")
endif(FREEDV_VERSION_TAG)

# Insert source and generated header directories before other search directories.
include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})

if(APPLE)
install(TARGETS FreeDV
    BUNDLE DESTINATION bin
)
else(APPLE)
install(TARGETS freedv
    RUNTIME DESTINATION bin
)
endif(APPLE)

# Custom commands to build OSX images.
if(APPLE)
    add_custom_command(
        TARGET FreeDV
        POST_BUILD
        COMMAND rm -rf dist_tmp FreeDV.dmg || true
        COMMAND DYLD_LIBRARY_PATH=${CODEC2_BUILD_DIR}/src:${LPCNET_BUILD_DIR}/src:${portaudio_BINARY_DIR}:${samplerate_BINARY_DIR}/src:${DYLD_LIBRARY_PATH} ${CMAKE_SOURCE_DIR}/macdylibbundler/dylibbundler ARGS -od -b -x FreeDV.app/Contents/MacOS/FreeDV -d FreeDV.app/Contents/libs -p @loader_path/../libs/ -i /usr/lib -s ${LPCNET_BUILD_DIR}/src -s ${CODEC2_BUILD_DIR}/src -s ${CMAKE_BINARY_DIR}/LPCNet_build/src -s ${CMAKE_BINARY_DIR}/codec2_build/src -s ${portaudio_BINARY_DIR} -s ${samplerate_BINARY_DIR}/src
        COMMAND cp ARGS ${CMAKE_CURRENT_SOURCE_DIR}/freedv.icns FreeDV.app/Contents/Resources
        COMMAND mkdir dist_tmp
        COMMAND cp -r FreeDV.app dist_tmp 
        COMMAND hdiutil create -srcfolder dist_tmp/ -volname FreeDV -format UDZO -fs HFS+ ./FreeDV.dmg
        COMMAND rm -rf dist_tmp
    )
endif(APPLE)

=== debian/changelog ===
freedv (1.8.7-1) unstable; urgency=medium

  * New upstream release.

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 20 Jan 2023 21:47:50 -0500

freedv (1.8.5-1) unstable; urgency=medium

  * New upstream release.
    Update FreeDV configuration defaults to improve first-time usability.

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 10 Dec 2022 15:45:18 -0500

freedv (1.8.4-1) unstable; urgency=medium

  [ Christoph Berg ]
  * Update watch file to look at github tags.

  [ A. Maitland Bottoms ]
  * New upstream release.

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 04 Nov 2022 10:17:11 -0400

freedv (1.8.3.1-3) unstable; urgency=medium

  * Team upload.
  * Update build-dep for wxWidgets to 3.2 (Closes: #1019794)
  * Update lintian-overrides

 -- tony mancill <tmancill@debian.org>  Fri, 16 Sep 2022 22:45:43 -0700

freedv (1.8.3.1-2) unstable; urgency=medium

  * Set USE_PULSEAUDIO correctly without gbp changing it. (Closes: 1006419)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 27 Aug 2022 16:39:51 -0400

freedv (1.8.3.1-1) unstable; urgency=medium

  * New upstream release.
  * Set USE_PULSEAUDIO correctly (Closes: 1006419)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 27 Aug 2022 16:24:16 -0400

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --builddir=Build --build-system=cmake

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
	 -DDEB_VERSION=$(DEB_VERSION) -DCMAKE_BUILD_TYPE=RelWithDebInfo -DUSE_STATIC_CODEC2=False \
	 -DUSE_STATIC_SPEEXDSP=False -DUSE_PULSEAUDIO=True

override_dh_auto_install:
	dh_auto_install
	rm -rf debian/freedv/usr/share/freedv-gui

## freedv 1.8.11

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 set(CMAKE_OSX_DEPLOYMENT_TARGET "10.11" CACHE STRING "Minimum OS X deployment version")
 
 set(PROJECT_NAME FreeDV)
-set(PROJECT_VERSION 1.8.7)
+set(PROJECT_VERSION 1.8.11)
 set(PROJECT_DESCRIPTION "HF Digital Voice for Radio Amateurs")
 set(PROJECT_HOMEPAGE_URL "https://freedv.org")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -31,9 +31,6 @@
     topFrame.h
     version.h
     osx_interface.h
-    pskreporter.cpp
-    pskreporter.h
-    udp.cpp
     util.cpp
     eq.cpp
     voicekeyer.cpp
@@ -41,6 +38,8 @@
     ongui.cpp
     freedv_interface.cpp
     freedv_interface.h        
+    wxListViewComboPopup.cpp
+    wxListViewComboPopup.h
 )
 
 set(FREEDV_SOURCES_OSX
@@ -54,6 +53,7 @@
 # Compile FreeDV components
 add_subdirectory(audio)
 add_subdirectory(pipeline)
+add_subdirectory(reporting)
 add_subdirectory(sox)
 
 # WIN32 is needed for Windows GUI apps and is ignored for UNIX like systems.
@@ -79,9 +79,9 @@
 
 # Link imported or build tree targets.
 if(APPLE)
-target_link_libraries(FreeDV fdv_audio fdv_audio_pipeline fdv_sox lpcnetfreedv codec2)
+target_link_libraries(FreeDV fdv_audio fdv_audio_pipeline fdv_reporting fdv_sox lpcnetfreedv codec2)
 else(APPLE)
-target_link_libraries(freedv fdv_audio fdv_audio_pipeline fdv_sox lpcnetfreedv codec2)
+target_link_libraries(freedv fdv_audio fdv_audio_pipeline fdv_reporting fdv_sox lpcnetfreedv codec2)
 endif(APPLE)
 
 # Add build dependencies for internally built external libraries.

=== src/audio/CMakeLists.txt ===
if(USE_PULSEAUDIO)
set(AUDIO_ENGINE_LIBRARY_SPECIFIC_FILES
    PulseAudioDevice.cpp
    PulseAudioEngine.cpp
    )

else(USE_PULSEAUDIO)
set(AUDIO_ENGINE_LIBRARY_SPECIFIC_FILES
    PortAudioDevice.cpp
    PortAudioEngine.cpp
    )

endif(USE_PULSEAUDIO)

add_library(fdv_audio STATIC
    AudioDeviceSpecification.cpp
    AudioEngineFactory.cpp
    IAudioDevice.cpp
    IAudioEngine.cpp
    ${AUDIO_ENGINE_LIBRARY_SPECIFIC_FILES}
)

if(BOOTSTRAP_WXWIDGETS)
    add_dependencies(fdv_audio wx::core wx::base wx::aui wx::html wx::net wx::adv wx::propgrid wx::xrc)
    target_compile_definitions(fdv_audio PRIVATE ${WXBUILD_BUILD_DEFS})
    target_include_directories(fdv_audio PRIVATE ${WXBUILD_INCLUDES})
endif(BOOTSTRAP_WXWIDGETS)

=== src/pipeline/CMakeLists.txt ===
add_library(fdv_audio_pipeline STATIC
    AudioPipeline.h
    AudioPipeline.cpp
    ComputeRfSpectrumStep.h
    ComputeRfSpectrumStep.cpp
    EitherOrStep.h
    EitherOrStep.cpp
    EqualizerStep.h
    EqualizerStep.cpp
    ExclusiveAccessStep.h
    ExclusiveAccessStep.cpp
    FreeDVReceiveStep.h
    FreeDVReceiveStep.cpp
    FreeDVTransmitStep.h
    FreeDVTransmitStep.cpp
    IPipelineStep.h
    IPipelineStep.cpp
    LevelAdjustStep.h
    LevelAdjustStep.cpp
    ParallelStep.h
    ParallelStep.cpp
    PlaybackStep.h
    PlaybackStep.cpp
    RecordStep.h
    RecordStep.cpp
    ResampleStep.h
    ResampleStep.cpp
    ResamplePlotStep.h
    ResamplePlotStep.cpp
    SpeexStep.h
    SpeexStep.cpp
    TapStep.h
    TapStep.cpp
    ToneInterfererStep.h
    ToneInterfererStep.cpp
    TxRxThread.h
    TxRxThread.cpp
)

target_include_directories(fdv_audio_pipeline PRIVATE ${CODEC2_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR}/.. ${CMAKE_CURRENT_BINARY_DIR}/..)

if(BOOTSTRAP_WXWIDGETS)
    add_dependencies(fdv_audio_pipeline wx::core wx::base wx::aui wx::html wx::net wx::adv wx::propgrid wx::xrc)
    target_compile_definitions(fdv_audio_pipeline PRIVATE ${WXBUILD_BUILD_DEFS})
    target_include_directories(fdv_audio_pipeline PRIVATE ${WXBUILD_INCLUDES})
endif(BOOTSTRAP_WXWIDGETS)

if(UNITTEST)
macro(DefineUnitTest utName)
    add_executable(${utName} test/${utName}.cpp)
    target_link_libraries(${utName} PRIVATE fdv_audio_pipeline)
    target_include_directories(${utName} PRIVATE ${CODEC2_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/.. ${CMAKE_CURRENT_BINARY_DIR}/..)
    
    add_test(NAME pipeline_${utName} COMMAND ${CMAKE_CURRENT_BINARY_DIR}/${utName})
endmacro()

DefineUnitTest(AudioPipelineTest)
target_link_libraries(AudioPipelineTest PRIVATE ${FREEDV_LINK_LIBS})
DefineUnitTest(EitherOrTest)
DefineUnitTest(ExclusiveAccessTest)
DefineUnitTest(LevelAdjustTest)
DefineUnitTest(ResampleTest)
target_link_libraries(ResampleTest PRIVATE ${FREEDV_LINK_LIBS})
DefineUnitTest(TapTest)
endif(UNITTEST)

=== src/reporting/CMakeLists.txt ===
add_library(fdv_reporting STATIC
    pskreporter.cpp
    pskreporter.h
    FreeDVReporter.cpp
    FreeDVReporter.h
)

if(SIOCLIENT_ADD_DEPENDENCY)
add_dependencies(fdv_reporting sioclient)
endif(SIOCLIENT_ADD_DEPENDENCY)

=== src/sox/CMakeLists.txt ===
add_library(fdv_sox STATIC
    band.h
    biquad.c
    biquads.c
    biquad.h
    effects.c
    effects.h
    effects_i.c
    effects_i_dsp.c
    fft4g.c
    formats.c
    formats_i.c
    libsox.c
    sox.h
    sox_i.h
    soxomp.h
    util.c
    util.h
    vol.c
    xmalloc.h
    xmalloc.c)

=== debian/changelog ===
freedv (1.8.11-1build4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 05:21:09 +0000

freedv (1.8.11-1build3) noble; urgency=high

  * No change rebuild against libwxbase3.2-1t64, libwxgtk3.2-1t64,
    libhamlib4t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 17:04:56 +0100

freedv (1.8.11-1build2) mantic; urgency=medium

  * Rebuild against new libcodec2-1.2.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 19 Aug 2023 00:23:41 +0200

freedv (1.8.11-1build1) mantic; urgency=medium

  * Rebuild against new libcodec2-1.1.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 18 Jul 2023 08:21:12 +0200

freedv (1.8.11-1) unstable; urgency=medium

  * New upstream release.

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 11 Jul 2023 13:10:52 -0400

=== debian/control ===
Source: freedv
Section: hamradio
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
Uploaders: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libcodec2-dev (>= 0.9),
               libhamlib-dev,
               libpulse-dev,
               libsamplerate-dev,
               libsndfile-dev,
               libspeexdsp-dev,
               libwxgtk3.2-dev,
               portaudio19-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://freedv.org/
Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/freedv
Vcs-Git: https://salsa.debian.org/debian-hamradio-team/freedv.git

Package: freedv
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Digital Voice mode for ham radio
 FreeDV is a digital voice mode intended for transmission and
 reception over high-frequency (HF) radio. It uses a frequency
 division multiplex (FDM) modem with 15 carriers and no forward error
 correction (FEC). A low bit-rate voice coder-decoder (Codec 2)
 provides voice quality without the listener fatigue caused by noise
 and interference normally associated with analog single sideband
 (SSB) voice. A HF SSB transceiver, personal computer and two sound
 cards are required. Path simulation and on-the-air HF testing have
 shown that decoding voice is possible at a signal-to-noise ratio of
 4 dB.
 .
 The FreeDV software was developed by David Rowe (Codec 2, FDM
 modem implementation, integration) and David Witten (GUI,
 architecture design). The FreeDV design and user interface was based
 on the earlier FDMDV program which was developed by Francesco
 Lanza. The FDM modem design and development was supported from Peter
 Martinez.

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,8 @@
 override_dh_auto_configure:
 	dh_auto_configure --buildsystem=cmake -- \
 	 -DDEB_VERSION=$(DEB_VERSION) -DCMAKE_BUILD_TYPE=RelWithDebInfo -DUSE_STATIC_CODEC2=False \
-	 -DUSE_STATIC_SPEEXDSP=False -DUSE_PULSEAUDIO=True
+	 -DUSE_STATIC_SPEEXDSP=False -DUSE_PULSEAUDIO=True \
+	 -DUSE_SIOCLIENT=OFF
 
 override_dh_auto_install:
 	dh_auto_install
